package xyz.lychee.lagfixer.libs.adventure.text.serializer.gson;

import java.io.IOException;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.event.HoverEvent;
import xyz.lychee.lagfixer.libs.adventure.util.Codec;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface LegacyHoverEventSerializer {
   HoverEvent.@NotNull ShowItem deserializeShowItem(final @NotNull Component input) throws IOException;

   HoverEvent.@NotNull ShowEntity deserializeShowEntity(final @NotNull Component input, final Codec.Decoder<Component, String, ? extends RuntimeException> componentDecoder) throws IOException;

   @NotNull Component serializeShowItem(final HoverEvent.@NotNull ShowItem input) throws IOException;

   @NotNull Component serializeShowEntity(final HoverEvent.@NotNull ShowEntity input, final Codec.Encoder<Component, String, ? extends RuntimeException> componentEncoder) throws IOException;
}
